#ifndef __MERLIN_H__
#define __MERLIN_H__ 1

#include <stdbool.h>
#include <stdint.h>

#define MERLIN_DEFAULT_PERIOD         7917
#define MERLIN_MAX_LEVEL              (MERLIN_DEFAULT_PERIOD * 2.5f)
#define MERLIN_MAX_SHORT_LEVEL        (MERLIN_DEFAULT_PERIOD * 1.5f)

#define MERLIN_SKIP_WIDTH             (MERLIN_DEFAULT_PERIOD * 13.5f)

#define MERLIN_MAX_DATA_LENGTH        96

#define MERLIN_TIMEOUT                80

#define MOUSE_SWITCH_KEYCODE          1

#define MAX_MOUSE_MOVEMENT            5

typedef struct merlin_s
{
	bool signal;
	bool log;
	uint16_t data[MERLIN_MAX_DATA_LENGTH];
	uint8_t data_pos;
	uint8_t keys[4];
	uint8_t n_keys;
	uint8_t mod_byte;
	uint8_t timeout;
	volatile bool write_in_progres;
	volatile bool mouse_mode;
	volatile uint8_t mouse_jump;
	volatile int8_t mouse_move_x;
	volatile int8_t mouse_move_y;
	volatile uint8_t buttons_pressed;
	volatile bool toggle_ready;
} merlin_s;

typedef struct merlin_mouse_s
{
	uint8_t left_key;
	uint8_t right_key;
	uint8_t up_key;
	uint8_t down_key;
	uint8_t b1;
	uint8_t b2;
} merlin_mouse_s;


extern merlin_s merlin;

extern merlin_mouse_s mouse;

extern const uint8_t merlin_keycodes[128];


void merlin_capture_init(void);
void merlin_eval(void);


#endif